.nolist
#include "asm.inc"
.list
.org $9D93
	.db $BB,$6D
	#define interval 9872h
	#define counter 9882h
	#define upperl 9892h
	#define sum 98A2h
	#define left 98B2h
	in a,(2)
	and 80h
	jr z,NotSE
	ld a,1
	out (20h),a
NotSE:
	call rclu
	bcall(_convop1)
	ld (left),de
	call rclt
	bcall(_convop1)
	or a
	jp nz,RightSum
	;Get interval
	call rcln
	ld hl,OP1
	ld de,interval
	ld bc,9
	ldir
	;Get lower bound
	bcall(_rclx)
	ld hl,OP1
	ld de,counter
	ld bc,9
	ldir
	;Get upper bound - interval
	bcall(_rcly)
	ld hl,interval
	ld de,OP2
	ld bc,9
	ldir
	bcall(_fpsub)	;subtract interval
	ld hl,OP1
	ld de,upperl
	ld bc,9
	ldir
	;Set (sum) = 0
	bcall(_op1set0)
	ld hl,OP1
	ld de,sum
	ld bc,9
	ldir
LeftSumLoop:
	ld hl,counter
	rst 20h
	bcall(_stox)	;(counter) = X
	ld hl,y1
	rst 20h
	bcall(_parseinp)	;Evaluate function at X
	ld hl,interval
	ld de,OP2
	ld bc,9
	ldir
	bcall(_fpmult)
	ld hl,sum
	ld de,OP2
	ld bc,9
	ldir
	bcall(_fpadd)
	ld hl,OP1
	ld de,sum
	ld bc,9
	ldir
	ld hl,interval
	rst 20h
	ld hl,counter
	ld de,OP2
	ld bc,9
	ldir
	bcall(_fpadd)
	ld hl,OP1
	ld de,counter
	ld bc,9
	ldir
	ld hl,(left)
	dec hl
	ld (left),hl
	ld a,h
	or l
	jp nz,LeftSumLoop
LeftSumDone:
	ld hl,sum
	rst 20h
	bcall(_stox)
	ret
RightSum:
	;Get interval
	call rcln
	ld hl,OP1
	ld de,interval
	ld bc,9
	ldir
	;Get lower bound + interval
	bcall(_rclx)
	ld hl,interval
	ld de,OP2
	ld bc,9
	ldir
	bcall(_fpadd)
	ld hl,OP1
	ld de,counter
	ld bc,9
	ldir
	;Get upper bound
	bcall(_rcly)
	ld hl,OP1
	ld de,upperl
	ld bc,9
	ldir
	;Set (sum) = 0
	bcall(_op1set0)
	ld hl,OP1
	ld de,sum
	ld bc,9
	ldir
	jp LeftSumLoop
y1:
	.db EquObj,$5E,$10,0,0,0
rcln:
	bcall(_zeroop1)
	ld hl,op1+1
	ld (hl),'N'
	bcall(_rclvarsym)
	ret
rclt:
	bcall(_zeroop1)
	ld hl,op1+1
	ld (hl),'T'
	bcall(_rclvarsym)
	ret
rclu:
	bcall(_zeroop1)
	ld hl,op1+1
	ld (hl),'U'
	bcall(_rclvarsym)
	ret
.end
